/* Actions (message types) */
mtype = { nop, a45, a47, a9, a18, a35, a6, a15, a46, a5, a48, a32, a40, a16, a13, a7, a3, a1, a17, a31, a36, a14, a4, a30, a33, a25, a10, a2, a8, a11, a29, a44, a28, a42, a22, a21, a34, a27, a12, a39, a41, a38, a19, a24, a23, a37, a20, a26, a43 };

/* Inter-process channels */
chan p6_4 = [0] of {mtype};
chan p7_4 = [0] of {mtype};
chan p4_3 = [0] of {mtype};
chan p9_3 = [0] of {mtype};
chan p4_2 = [0] of {mtype};
chan p8_2 = [0] of {mtype};
chan p6_1 = [0] of {mtype};
chan p5_0 = [0] of {mtype};
chan p4_0 = [0] of {mtype};

/* Environement<->process channels */
chan p7 = [0] of {mtype};
chan p4 = [0] of {mtype};
chan p3 = [0] of {mtype};
chan p2 = [0] of {mtype};
chan p6 = [0] of {mtype};
chan p9 = [0] of {mtype};
chan p8 = [0] of {mtype};
chan p5 = [0] of {mtype};
chan p1 = [0] of {mtype};
chan p0 = [0] of {mtype};

/* Environment process */
active proctype Environment()
{
  do
  :: p7 ! a45
  :: p7 ! a47
  :: p4 ! a9
  :: p4 ! a18
  :: p4 ! a35
  :: p4 ! a6
  :: p4 ! a15
  :: p7 ! a46
  :: p7 ! a48
  :: p4 ! a32
  :: p4 ! a40
  :: p4 ! a16
  :: p4 ! a13
  :: p4 ! a3
  :: p4 ! a31
  :: p4 ! a2
  :: p4 ! a11
  :: p3 ! a28
  :: p4 ! a12
  :: p4 ! a39
  :: p4 ! a38
  :: p2 ! a24
  :: p4 ! a37
  :: p6 ! a43
  :: p9 ! nop
  :: p8 ! nop
  :: p7 ! nop
  :: p6 ! nop
  :: p5 ! nop
  :: p4 ! nop
  :: p3 ! nop
  :: p2 ! nop
  :: p1 ! nop
  :: p0 ! nop
  od
}

/* Action channel */
chan act = [0] of {mtype};

/* Most recent message event */
mtype lastAction = nop;

/* Action listener */
active proctype Listener()
{
  atomic {
    do
    :: act ? lastAction ->
  step: skip
    od
  }
}

/* Process 0 */
active proctype Proc0()
{
  int state = 13;
  do
  :: state == 13 ->
    atomic {
      if
      :: p0 ? nop ->

        state = 8;
      fi
    }
  :: state == 8 ->
    atomic {
      if
      :: p4_0 ? a19 ->
        act ! a19;
        state = 1;
      :: p4_0 ? a21 ->
        act ! a21;
        state = 9;
      fi
    }
  :: state == 1 ->
    atomic {
      if
      :: p5_0 ? a22 ->
        act ! a22;
        state = 7;
      fi
    }
  :: state == 9 ->
    atomic {
      if
      :: p5_0 ? a22 ->
        act ! a22;
        state = 10;
      fi
    }
  :: state == 7 ->
    atomic {
      if
      :: p5_0 ? a23 ->
        act ! a23;
        state = 4;
      fi
    }
  :: state == 10 ->
    atomic {
      if
      :: p5_0 ? a23 ->
        act ! a23;
        state = 2;
      fi
    }
  :: state == 4 ->
    atomic {
      if
      :: p5_0 ? a41 ->
        act ! a41;
        state = 8;
      fi
    }
  :: state == 2 ->
    atomic {
      if
      :: p5_0 ? a41 ->
        act ! a41;
        state = 11;
      fi
    }
  :: state == 11 ->
    atomic {
      if
      :: p4_0 ? a20 ->
        act ! a20;
        state = 1;
      :: p4_0 ? a19 ->
        act ! a19;
        state = 5;
      :: p4_0 ? a21 ->
        act ! a21;
        state = 5;
      fi
    }
  :: state == 5 ->
    atomic {
      if
      :: p5_0 ? a22 ->
        act ! a22;
        state = 12;
      fi
    }
  :: state == 12 ->
    atomic {
      if
      :: p5_0 ? a23 ->
        act ! a23;
        state = 6;
      fi
    }
  :: state == 6 ->
    atomic {
      if
      :: p5_0 ? a41 ->
        act ! a41;
        state = 3;
      fi
    }
  :: state == 3 ->
    atomic {
      if
      :: p4_0 ? a19 ->
        act ! a19;
        state = 5;
      fi
    }
  od
}

/* Process 1 */
active proctype Proc1()
{
  int state = 17;
  do
  :: state == 17 ->
    atomic {
      if
      :: p1 ? nop ->

        state = 16;
      fi
    }
  :: state == 16 ->
    atomic {
      if
      :: p6_1 ? a42 ->
        act ! a42;
        state = 15;
      fi
    }
  :: state == 15 ->
    atomic {
      if
      :: p6_1 ? a44 ->
        act ! a44;
        state = 16;
      :: p6_1 ? a42 ->
        act ! a42;
        state = 14;
      fi
    }
  :: state == 14 ->
    atomic {
      if
      :: p6_1 ? a42 ->
        act ! a42;
        state = 14;
      fi
    }
  od
}

/* Process 2 */
active proctype Proc2()
{
  int state = 28;
  do
  :: state == 28 ->
    atomic {
      if
      :: p2 ? nop ->

        state = 18;
      fi
    }
  :: state == 18 ->
    atomic {
      if
      :: p4_2 ? a34 ->
        act ! a34;
        state = 19;
      :: p4_2 ? a8 ->
        act ! a8;
        state = 27;
      fi
    }
  :: state == 19 ->
    atomic {
      if
      :: p8_2 ? a26 ->
        act ! a26;
        state = 22;
      fi
    }
  :: state == 27 ->
    atomic {
      if
      :: p8_2 ? a26 ->
        act ! a26;
        state = 24;
      fi
    }
  :: state == 22 ->
    atomic {
      if
      :: p2 ? a24 ->
        act ! a24;
        state = 26;
      fi
    }
  :: state == 24 ->
    atomic {
      if
      :: p2 ? a24 ->
        act ! a24;
        state = 21;
      fi
    }
  :: state == 26 ->
    atomic {
      if
      :: p8_2 ? a25 ->
        act ! a25;
        state = 23;
      fi
    }
  :: state == 21 ->
    atomic {
      if
      :: p8_2 ? a25 ->
        act ! a25;
        state = 20;
      fi
    }
  :: state == 23 ->
    atomic {
      if
      :: p8_2 ? a29 ->
        act ! a29;
        state = 25;
      fi
    }
  :: state == 20 ->
    atomic {
      if
      :: p8_2 ? a29 ->
        act ! a29;
        state = 18;
      fi
    }
  :: state == 25 ->
    atomic {
      if
      :: p4_2 ? a33 ->
        act ! a33;
        state = 27;
      fi
    }
  od
}

/* Process 3 */
active proctype Proc3()
{
  int state = 42;
  do
  :: state == 42 ->
    atomic {
      if
      :: p3 ? nop ->

        state = 36;
      fi
    }
  :: state == 36 ->
    atomic {
      if
      :: p4_3 ? a36 ->
        act ! a36;
        state = 37;
      :: p4_3 ? a14 ->
        act ! a14;
        state = 29;
      fi
    }
  :: state == 37 ->
    atomic {
      if
      :: p9_3 ? a30 ->
        act ! a30;
        state = 38;
      fi
    }
  :: state == 29 ->
    atomic {
      if
      :: p9_3 ? a30 ->
        act ! a30;
        state = 35;
      fi
    }
  :: state == 38 ->
    atomic {
      if
      :: p9_3 ? a27 ->
        act ! a27;
        state = 30;
      fi
    }
  :: state == 35 ->
    atomic {
      if
      :: p9_3 ? a27 ->
        act ! a27;
        state = 39;
      fi
    }
  :: state == 30 ->
    atomic {
      if
      :: p9_3 ? a27 ->
        act ! a27;
        state = 32;
      :: p3 ? a28 ->
        act ! a28;
        state = 36;
      fi
    }
  :: state == 39 ->
    atomic {
      if
      :: p3 ? a28 ->
        act ! a28;
        state = 40;
      fi
    }
  :: state == 32 ->
    atomic {
      if
      :: p4_3 ? a14 ->
        act ! a14;
        state = 32;
      :: p4_3 ? a36 ->
        act ! a36;
        state = 32;
      :: p3 ? a28 ->
        act ! a28;
        state = 32;
      fi
    }
  :: state == 40 ->
    atomic {
      if
      :: p4_3 ? a14 ->
        act ! a14;
        state = 33;
      :: p4_3 ? a17 ->
        act ! a17;
        state = 37;
      fi
    }
  :: state == 33 ->
    atomic {
      if
      :: p9_3 ? a30 ->
        act ! a30;
        state = 41;
      fi
    }
  :: state == 41 ->
    atomic {
      if
      :: p9_3 ? a27 ->
        act ! a27;
        state = 34;
      fi
    }
  :: state == 34 ->
    atomic {
      if
      :: p3 ? a28 ->
        act ! a28;
        state = 31;
      fi
    }
  :: state == 31 ->
    atomic {
      if
      :: p4_3 ? a14 ->
        act ! a14;
        state = 33;
      fi
    }
  od
}

/* Process 4 */
active proctype Proc4()
{
  int state = 68;
  do
  :: state == 68 ->
    atomic {
      if
      :: p4 ? nop ->

        state = 48;
      fi
    }
  :: state == 48 ->
    atomic {
      if
      :: p4 ? a38 ->
        act ! a38;
        state = 47;
      fi
    }
  :: state == 47 ->
    atomic {
      if
      :: p4 ? a37 ->
        act ! a37;
        state = 46;
      :: p4_2 ! a34 ->

        state = 52;
      :: p4_3 ! a14 ->

        state = 45;
      :: p7_4 ? a10 ->
        act ! a10;
        state = 49;
      :: p4 ? a6 ->
        act ! a6;
        state = 50;
      :: p4_3 ! a36 ->

        state = 51;
      fi
    }
  :: state == 46 ->
    atomic {
      if
      :: p7_4 ? a1 ->
        act ! a1;
        state = 43;
      :: p4 ? a40 ->
        act ! a40;
        state = 44;
      fi
    }
  :: state == 52 ->
    atomic {
      if
      :: p4_2 ! a33 ->

        state = 47;
      fi
    }
  :: state == 45 ->
    atomic {
      if
      :: p4_3 ! a17 ->

        state = 51;
      fi
    }
  :: state == 49 ->
    atomic {
      if
      :: p7_4 ? a1 ->
        act ! a1;
        state = 55;
      fi
    }
  :: state == 50 ->
    atomic {
      if
      :: p6_4 ? a7 ->
        act ! a7;
        state = 51;
      fi
    }
  :: state == 51 ->
    atomic {
      if
      :: p4 ? a16 ->
        act ! a16;
        state = 56;
      :: p4 ? a35 ->
        act ! a35;
        state = 47;
      :: p4_2 ! a8 ->

        state = 44;
      fi
    }
  :: state == 43 ->
    atomic {
      if
      :: p4_2 ! a8 ->

        state = 43;
      :: p6_4 ? a4 ->
        act ! a4;
        state = 43;
      :: p4 ? a2 ->
        act ! a2;
        state = 67;
      :: p4 ? a3 ->
        act ! a3;
        state = 43;
      :: p4_3 ! a17 ->

        state = 43;
      :: p6_4 ? a7 ->
        act ! a7;
        state = 43;
      :: p4 ? a12 ->
        act ! a12;
        state = 43;
      :: p4_2 ! a34 ->

        state = 43;
      :: p4_2 ! a33 ->

        state = 43;
      :: p4 ? a31 ->
        act ! a31;
        state = 43;
      :: p4 ? a13 ->
        act ! a13;
        state = 43;
      :: p4 ? a16 ->
        act ! a16;
        state = 43;
      :: p4_0 ! a19 ->

        state = 43;
      fi
    }
  :: state == 44 ->
    atomic {
      if
      :: p4 ? a39 ->
        act ! a39;
        state = 48;
      :: p4 ? a32 ->
        act ! a32;
        state = 56;
      :: p4 ? a3 ->
        act ! a3;
        state = 53;
      fi
    }
  :: state == 55 ->
    atomic {
      if
      :: p4 ? a2 ->
        act ! a2;
        state = 54;
      fi
    }
  :: state == 56 ->
    atomic {
      if
      :: p4_0 ! a21 ->

        state = 59;
      :: p4 ? a31 ->
        act ! a31;
        state = 57;
      :: p4 ? a13 ->
        act ! a13;
        state = 58;
      fi
    }
  :: state == 67 ->
    atomic {
      if
      :: p4 ? a2 ->
        act ! a2;
        state = 64;
      :: p4_0 ! a21 ->

        state = 67;
      :: p4 ? a12 ->
        act ! a12;
        state = 67;
      :: p4_3 ! a14 ->

        state = 67;
      :: p4_0 ! a20 ->

        state = 67;
      :: p4 ? a37 ->
        act ! a37;
        state = 67;
      :: p4 ? a35 ->
        act ! a35;
        state = 67;
      :: p7_4 ? a1 ->
        act ! a1;
        state = 67;
      :: p4_3 ! a36 ->

        state = 67;
      :: p4 ? a39 ->
        act ! a39;
        state = 67;
      :: p4 ? a40 ->
        act ! a40;
        state = 67;
      :: p4 ? a3 ->
        act ! a3;
        state = 67;
      :: p4 ? a11 ->
        act ! a11;
        state = 67;
      :: p7_4 ? a10 ->
        act ! a10;
        state = 67;
      :: p6_4 ? a5 ->
        act ! a5;
        state = 67;
      :: p4 ? a9 ->
        act ! a9;
        state = 43;
      :: p4_2 ! a8 ->

        state = 67;
      fi
    }
  :: state == 53 ->
    atomic {
      if
      :: p6_4 ? a4 ->
        act ! a4;
        state = 63;
      fi
    }
  :: state == 54 ->
    atomic {
      if
      :: p4 ? a11 ->
        act ! a11;
        state = 66;
      fi
    }
  :: state == 59 ->
    atomic {
      if
      :: p4_2 ! a33 ->

        state = 62;
      :: p4_0 ! a20 ->

        state = 61;
      fi
    }
  :: state == 57 ->
    atomic {
      if
      :: p4_0 ! a19 ->

        state = 44;
      fi
    }
  :: state == 58 ->
    atomic {
      if
      :: p4 ? a12 ->
        act ! a12;
        state = 47;
      fi
    }
  :: state == 64 ->
    atomic {
      if
      :: p4_0 ! a21 ->

        state = 64;
      :: p4_0 ! a19 ->

        state = 64;
      :: p4 ? a15 ->
        act ! a15;
        state = 64;
      :: p4_0 ! a20 ->

        state = 64;
      :: p4 ? a37 ->
        act ! a37;
        state = 64;
      :: p4_3 ! a17 ->

        state = 64;
      :: p4_3 ! a14 ->

        state = 64;
      :: p4 ? a12 ->
        act ! a12;
        state = 64;
      :: p4 ? a31 ->
        act ! a31;
        state = 64;
      :: p4_3 ! a36 ->

        state = 64;
      :: p4 ? a3 ->
        act ! a3;
        state = 64;
      :: p6_4 ? a7 ->
        act ! a7;
        state = 64;
      :: p4 ? a2 ->
        act ! a2;
        state = 64;
      fi
    }
  :: state == 63 ->
    atomic {
      if
      :: p6_4 ? a5 ->
        act ! a5;
        state = 47;
      fi
    }
  :: state == 66 ->
    atomic {
      if
      :: p4 ? a9 ->
        act ! a9;
        state = 47;
      fi
    }
  :: state == 62 ->
    atomic {
      if
      :: p4_0 ! a20 ->

        state = 62;
      :: p4 ? a13 ->
        act ! a13;
        state = 62;
      :: p4 ? a12 ->
        act ! a12;
        state = 62;
      :: p4_2 ! a33 ->

        state = 62;
      :: p4 ? a40 ->
        act ! a40;
        state = 62;
      :: p4 ? a39 ->
        act ! a39;
        state = 62;
      :: p4 ? a32 ->
        act ! a32;
        state = 62;
      :: p4_3 ! a36 ->

        state = 62;
      :: p4 ? a35 ->
        act ! a35;
        state = 62;
      :: p4 ? a6 ->
        act ! a6;
        state = 62;
      :: p4_2 ! a8 ->

        state = 62;
      :: p6_4 ? a7 ->
        act ! a7;
        state = 62;
      fi
    }
  :: state == 61 ->
    atomic {
      if
      :: p4 ? a15 ->
        act ! a15;
        state = 65;
      fi
    }
  :: state == 65 ->
    atomic {
      if
      :: p4 ? a18 ->
        act ! a18;
        state = 56;
      :: p4_3 ! a17 ->

        state = 60;
      :: p4_2 ! a33 ->

        state = 62;
      fi
    }
  :: state == 60 ->
    atomic {
      if
      :: p4_0 ! a20 ->

        state = 60;
      :: p4_2 ! a33 ->

        state = 60;
      :: p4_0 ! a19 ->

        state = 60;
      :: p4_3 ! a14 ->

        state = 60;
      :: p4 ? a16 ->
        act ! a16;
        state = 60;
      :: p4 ? a32 ->
        act ! a32;
        state = 60;
      :: p4 ? a31 ->
        act ! a31;
        state = 60;
      :: p7_4 ? a10 ->
        act ! a10;
        state = 60;
      :: p4 ? a11 ->
        act ! a11;
        state = 60;
      :: p4 ? a3 ->
        act ! a3;
        state = 60;
      :: p6_4 ? a4 ->
        act ! a4;
        state = 60;
      fi
    }
  od
}

/* Process 5 */
active proctype Proc5()
{
  int state = 73;
  do
  :: state == 73 ->
    atomic {
      if
      :: p5 ? nop ->

        state = 72;
      fi
    }
  :: state == 72 ->
    atomic {
      if
      :: p5_0 ! a41 ->

        state = 70;
      :: p5_0 ! a22 ->

        state = 71;
      fi
    }
  :: state == 70 ->
    atomic {
      if
      :: p5_0 ! a23 ->

        state = 70;
      fi
    }
  :: state == 71 ->
    atomic {
      if
      :: p5_0 ! a23 ->

        state = 69;
      fi
    }
  :: state == 69 ->
    atomic {
      if
      :: p5_0 ! a41 ->

        state = 72;
      :: p5_0 ! a23 ->

        state = 70;
      fi
    }
  od
}

/* Process 6 */
active proctype Proc6()
{
  int state = 87;
  do
  :: state == 87 ->
    atomic {
      if
      :: p6 ? nop ->

        state = 74;
      fi
    }
  :: state == 74 ->
    atomic {
      if
      :: p6_4 ! a7 ->

        state = 76;
      :: p6_4 ! a4 ->

        state = 78;
      fi
    }
  :: state == 76 ->
    atomic {
      if
      :: p6_1 ! a42 ->

        state = 81;
      fi
    }
  :: state == 78 ->
    atomic {
      if
      :: p6_1 ! a42 ->

        state = 82;
      fi
    }
  :: state == 81 ->
    atomic {
      if
      :: p6 ? a43 ->
        act ! a43;
        state = 85;
      fi
    }
  :: state == 82 ->
    atomic {
      if
      :: p6 ? a43 ->
        act ! a43;
        state = 83;
      fi
    }
  :: state == 85 ->
    atomic {
      if
      :: p6_1 ! a44 ->

        state = 74;
      fi
    }
  :: state == 83 ->
    atomic {
      if
      :: p6_1 ! a44 ->

        state = 75;
      fi
    }
  :: state == 75 ->
    atomic {
      if
      :: p6_4 ! a4 ->

        state = 80;
      :: p6_4 ! a5 ->

        state = 76;
      :: p6_4 ! a7 ->

        state = 80;
      fi
    }
  :: state == 80 ->
    atomic {
      if
      :: p6_1 ! a44 ->

        state = 77;
      :: p6_1 ! a42 ->

        state = 86;
      fi
    }
  :: state == 77 ->
    atomic {
      if
      :: p6_4 ! a4 ->

        state = 77;
      :: p6_1 ! a42 ->

        state = 77;
      :: p6_4 ! a7 ->

        state = 77;
      :: p6 ? a43 ->
        act ! a43;
        state = 77;
      fi
    }
  :: state == 86 ->
    atomic {
      if
      :: p6 ? a43 ->
        act ! a43;
        state = 84;
      fi
    }
  :: state == 84 ->
    atomic {
      if
      :: p6_1 ! a44 ->

        state = 79;
      fi
    }
  od
}

/* Process 7 */
active proctype Proc7()
{
  int state = 98;
  do
  :: state == 98 ->
    atomic {
      if
      :: p7 ? nop ->

        state = 92;
      fi
    }
  :: state == 92 ->
    atomic {
      if
      :: p7_4 ! a10 ->

        state = 97;
      fi
    }
  :: state == 97 ->
    atomic {
      if
      :: p7 ? a45 ->
        act ! a45;
        state = 90;
      fi
    }
  :: state == 90 ->
    atomic {
      if
      :: p7 ? a46 ->
        act ! a46;
        state = 95;
      fi
    }
  :: state == 95 ->
    atomic {
      if
      :: p7 ? a47 ->
        act ! a47;
        state = 96;
      fi
    }
  :: state == 96 ->
    atomic {
      if
      :: p7 ? a48 ->
        act ! a48;
        state = 94;
      fi
    }
  :: state == 94 ->
    atomic {
      if
      :: p7_4 ! a1 ->

        state = 93;
      fi
    }
  :: state == 93 ->
    atomic {
      if
      :: p7 ? a45 ->
        act ! a45;
        state = 88;
      fi
    }
  :: state == 88 ->
    atomic {
      if
      :: p7 ? a46 ->
        act ! a46;
        state = 91;
      fi
    }
  :: state == 91 ->
    atomic {
      if
      :: p7 ? a47 ->
        act ! a47;
        state = 89;
      fi
    }
  :: state == 89 ->
    atomic {
      if
      :: p7 ? a48 ->
        act ! a48;
        state = 92;
      fi
    }
  od
}

/* Process 8 */
active proctype Proc8()
{
  int state = 103;
  do
  :: state == 103 ->
    atomic {
      if
      :: p8 ? nop ->

        state = 102;
      fi
    }
  :: state == 102 ->
    atomic {
      if
      :: p8_2 ! a29 ->

        state = 100;
      :: p8_2 ! a26 ->

        state = 101;
      fi
    }
  :: state == 100 ->
    atomic {
      if
      :: p8_2 ! a29 ->

        state = 100;
      fi
    }
  :: state == 101 ->
    atomic {
      if
      :: p8_2 ! a25 ->

        state = 99;
      fi
    }
  :: state == 99 ->
    atomic {
      if
      :: p8_2 ! a29 ->

        state = 102;
      :: p8_2 ! a25 ->

        state = 100;
      fi
    }
  od
}

/* Process 9 */
active proctype Proc9()
{
  int state = 108;
  do
  :: state == 108 ->
    atomic {
      if
      :: p9 ? nop ->

        state = 107;
      fi
    }
  :: state == 107 ->
    atomic {
      if
      :: p9_3 ! a30 ->

        state = 106;
      fi
    }
  :: state == 106 ->
    atomic {
      if
      :: p9_3 ! a30 ->

        state = 105;
      :: p9_3 ! a27 ->

        state = 104;
      fi
    }
  :: state == 105 ->
    atomic {
      if
      :: p9_3 ! a30 ->

        state = 105;
      fi
    }
  :: state == 104 ->
    atomic {
      if
      :: p9_3 ! a30 ->

        state = 106;
      fi
    }
  od
}

#define p_a45	 (lastAction == a45)
#define p_a47	 (lastAction == a47)
#define p_a9	 (lastAction == a9)
#define p_a18	 (lastAction == a18)
#define p_a35	 (lastAction == a35)
#define p_a6	 (lastAction == a6)
#define p_a15	 (lastAction == a15)
#define p_a46	 (lastAction == a46)
#define p_a5	 (lastAction == a5)
#define p_a48	 (lastAction == a48)
#define p_a32	 (lastAction == a32)
#define p_a40	 (lastAction == a40)
#define p_a16	 (lastAction == a16)
#define p_a13	 (lastAction == a13)
#define p_a7	 (lastAction == a7)
#define p_a3	 (lastAction == a3)
#define p_a1	 (lastAction == a1)
#define p_a17	 (lastAction == a17)
#define p_a31	 (lastAction == a31)
#define p_a36	 (lastAction == a36)
#define p_a14	 (lastAction == a14)
#define p_a4	 (lastAction == a4)
#define p_a30	 (lastAction == a30)
#define p_a33	 (lastAction == a33)
#define p_a25	 (lastAction == a25)
#define p_a10	 (lastAction == a10)
#define p_a2	 (lastAction == a2)
#define p_a8	 (lastAction == a8)
#define p_a11	 (lastAction == a11)
#define p_a29	 (lastAction == a29)
#define p_a44	 (lastAction == a44)
#define p_a28	 (lastAction == a28)
#define p_a42	 (lastAction == a42)
#define p_a22	 (lastAction == a22)
#define p_a21	 (lastAction == a21)
#define p_a34	 (lastAction == a34)
#define p_a27	 (lastAction == a27)
#define p_a12	 (lastAction == a12)
#define p_a39	 (lastAction == a39)
#define p_a41	 (lastAction == a41)
#define p_a38	 (lastAction == a38)
#define p_a19	 (lastAction == a19)
#define p_a24	 (lastAction == a24)
#define p_a23	 (lastAction == a23)
#define p_a37	 (lastAction == a37)
#define p_a20	 (lastAction == a20)
#define p_a26	 (lastAction == a26)
#define p_a43	 (lastAction == a43)


ltl p1	 { [](!p_a20 || <>p_a18) }
ltl p2	 { (p_a10 || p_a34) V (!p_a6 || p_a10 || p_a34) }
ltl p3	 { p_a38 V (!p_a8 || p_a38) }
ltl p4	 { (p_a19 || p_a38) V (!p_a6 || p_a19 || p_a38) }
ltl p5	 { (!p_a5 || []!p_a9) U (p_a37 || p_a38) }
ltl p6	 { <>(p_a10 V (!p_a2 || p_a10)) }
ltl p7	 { !p_a8 U (p_a13 || p_a32) }
ltl p8	 { [](!p_a19 || (p_a34 V (p_a34 || !p_a40))) }
ltl p9	 { [](!p_a3 || []!p_a39) }
ltl p10	 { (p_a21 || p_a33) V (!p_a15 || p_a21 || p_a33 || (!p_a5 U p_a19)) }
ltl p11	 { !(p_a11 || p_a36) U p_a38 }
ltl p12	 { (!p_a36 || (!p_a37 U p_a32)) U (p_a13 || p_a34) }
ltl p13	 { <>p_a31 }
ltl p14	 { <>(p_a38 V (!p_a6 || p_a38)) }
ltl p15	 { <>(p_a8 && []!p_a7) }
ltl p16	 { !(p_a1 || p_a31) U p_a38 }
ltl p17	 { (!p_a34 || <>p_a40) U p_a38 }
ltl p18	 { (!p_a34 || <>p_a6) U p_a19 }
ltl p19	 { (!p_a17 || (p_a18 V (!p_a12 || p_a18))) U (p_a31 || p_a38) }
ltl p20	 { (p_a7 || p_a38) V (p_a7 || !p_a12 || p_a38) }
